<template>
  <div class="page">
    <div
      v-if="routeFrom && (routeFrom.name === 'Accounts' || routeFrom.name === null)"
      class="back-link"
      @click="$router.push(routeFrom)"
    >
      <b-icon-chevron-left font-scale="1.3" />
      <span>
        Gestion des comptes
      </span>
    </div>
    <div
      v-else
      class="back-link"
      @click="$router.push({ name: 'Organisations' })"
    >
      <b-icon-chevron-left font-scale="1.3" />
      <span>
        Liste des organisations
      </span>
    </div>
    <div
      class="add-orga-form"
    >
      <b-overlay
        id="overlay-background"
        :show="loading"
        :variant="'white'"
        :opacity="0.7"
        :blur="'2px'"
        rounded="sm"
        no-wrap
      >
      </b-overlay>
      <h2>Ajouter une organisation</h2>
      <ValidationObserver v-slot="{ handleSubmit }">
        <form>
          <h3 class="line-header">
            <img
              src="@/assets/icons/company.svg"
              alt="Icône organisation"
            /> Description
          </h3>
          <div class="form-row">
            <div class="form-group col-6">
              <label class="required">{{ labelIdComp }}</label>
              <input
                v-model="form.additional_id"
                class="form-control"
                type="text"
              >
            </div>
          </div>
          <div class="form-row">
            <div class="form-group col-12">
              <ValidationProvider ref="display_name" rules="required" v-slot="{ classes, errors }">
                <div class="control" :class="classes">
                  <label class="required">Nom de l'organisation</label>
                  <p>Inscrire le nom complet et en toutes lettres de l'organisation. Ex: Communauté des Communes Rurales de l'Entre-Deux-Mers</p>
                  <input
                    v-model="form.display_name"
                    class="form-control"
                    type="text"
                    placeholder="Nom de l'organisation"
                  >
                  <span class="form-errors">{{ errors[0] }}</span>
                </div>
              </ValidationProvider>
            </div>
          </div>
          <div class="form-row">
            <div class="form-group col-6">
              <ValidationProvider ref="acronym" v-slot="{ classes, errors }">
                <div class="control" :class="classes">
                  <label>Sigle</label>
                  <input
                    v-model="form.acronym"
                    class="form-control"
                    type="text"
                    placeholder="Sigle"
                  >
                  <span class="form-errors">{{ errors[0] }}</span>
                </div>
              </ValidationProvider>
            </div>
            <div class="form-group col-6">
              <ValidationProvider ref="registration_number" v-slot="{ classes, errors }">
                <div class="control" :class="classes">
                  <label>Numéro de SIRET</label>
                  <input
                    v-model="form.registration_number"
                    class="form-control"
                    type="text"
                    placeholder="Numéro de SIRET"
                  >
                  <span class="form-errors">{{ errors[0] }}</span>
                </div>
              </ValidationProvider>
            </div>
          </div>
          <div class="form-row">
            <div class="form-group col-6">
              <ValidationProvider ref="organisation_type" rules="required" v-slot="{ classes, errors }">
                <div class="control" :class="classes">
                  <label class="required">Type d'organisation</label>
                  <Multiselect
                    v-model="form.organisation_type"
                    :options="typesOrganisations"
                    track-by="choice"
                    label="label"
                    selectLabel=""
                    selectedLabel=""
                    deselectLabel=""
                    :searchable="false"
                    placeholder="Type d'organisation"
                  />
                  <span class="form-errors">{{ errors[0] }}</span>
                </div>
              </ValidationProvider>
            </div>
          </div>
          <div class="form-row">
            <div class="form-group col-6">
              <label>Logo de l'organisation</label>
              <p>Importer un logo au format JPG ou PNG (taille maximale: 2Mo)</p>
              <ValidationProvider ref="thumbnail" v-slot="{ classes, errors }">
                <div class="control" :class="classes">
                  <ImportImage
                    name="logo"
                    :title="null"
                    :file="null"
                    @update="setThumbnail"
                  />
                  <span class="form-errors">{{ errors[0] }}</span>
                </div>
              </ValidationProvider>
            </div>
          </div>
          <div class="form-row">
            <div class="form-group col-9">
              <ValidationProvider ref="website_url" v-slot="{ classes, errors }">
                <div class="control" :class="classes">
                  <label>Site web de l'organisation</label>
                  <input
                    v-model="form.website_url"
                    class="form-control"
                    type="text"
                    placeholder="Site web de l'organisation"
                    @focus="form.website_url === null ? form.website_url = 'https://' : null"
                    @blur="form.website_url === 'https://' ? form.website_url = null : null"
                  >
                  <span class="form-errors">{{ errors[0] }}</span>
                </div>
              </ValidationProvider>
            </div>
          </div>
          <div class="form-row">
            <div class="form-group col-12">
              <ValidationProvider ref="description" v-slot="{ classes, errors }">
                <div class="control" :class="classes">
                  <label>Description de l'organisation</label>
                  <textarea
                    v-model="form.description"
                    class="form-control"
                  />
                  <span class="form-errors">{{ errors[0] }}</span>
                </div>
              </ValidationProvider>
            </div>
          </div>
          <h3 class="line-header">
            <img
              src="@/assets/icons/mail.svg"
              alt="Icône enveloppe"
            /> Coordonnées
          </h3>
          <div class="form-row">
            <div class="form-group col-6">
              <ValidationProvider ref="phone_number" v-slot="{ classes, errors }">
                <div class="control" :class="classes">
                  <label>Téléphone</label>
                  <input
                    v-model="form.phone_number"
                    class="form-control"
                    type="text"
                    placeholder="Téléphone"
                  >
                  <span class="form-errors">{{ errors[0] }}</span>
                </div>
              </ValidationProvider>
            </div>
          </div>
          <div class="form-row">
            <div class="form-group col-12">
              <ValidationProvider ref="postal_address" v-slot="{ classes, errors }">
                <div class="control" :class="classes">
                  <label>Adresse postale</label>
                  <textarea
                    v-model="form.postal_address"
                    class="form-control"
                    type="text"
                    placeholder="Adresse postale"
                    rows="2"
                  />
                  <span class="form-errors">{{ errors[0] }}</span>
                </div>
              </ValidationProvider>
            </div>
          </div>

          <!-- Territoire -->
          <h3 class="line-header">
            <img
              src="@/assets/icons/territory_map_cadastre.svg"
              alt="Icône carte cadastrale"
            /> Territoire
          </h3>
          <div class="form-row">
            <div class="form-check" style="margin-left: -1em;">
              <input
                v-model="territoireCheckbox"
                class="form-check-input-table"
                type="checkbox"
              >
              <label class="form-check-label">
                L'organisation n'est pas rattaché à un territoire
              </label>
            </div>
          </div>
          <div
            class="form-row"
            :class="{ disabled: territoireCheckbox }"
          >
            <div class="form-group col-8">
              <label>Territoire</label>
              <Multiselect
                v-model="form.jurisdiction"
                :options="organisationsJuridictions"
                track-by="id"
                label="display_name"
                select-label=""
                selected-label=""
                deselect-label=""
                :searchable="false"
                :preserve-search="true"
                :show-no-results="false"
                placeholder="Sélectionner un territoire"
              />
            </div>
          </div>

          <!-- Convention -->
          <h3 class="line-header">
            <img
              src="@/assets/icons/official_document_convention.svg"
              alt="Icône document convention"
            /> Convention
          </h3>
          <div class="form-row">
            <div class="form-check" style="margin-left: -1em;">
              <input
                v-model="form.agreement_signed"
                class="form-check-input-table"
                type="checkbox"
              >
              <label class="form-check-label">
                L'organisation a signé une convention
              </label>
            </div>
          </div>
          <div
            class="form-row"
          >
            <div class="form-group col-8" style="margin-left: 1em;">
              <label>Convention</label>
              <ImportFile
                name="agreement"
                :type="'convention'"
                :title="null"
                :fileName="null"
                accept="application/*"
                @update="setAgreement"
              />
            </div>
          </div>
          <div
            class="form-row"
          >
            <div class="form-group col">
              <h3 class="line-header">
                <img
                  src="@/assets/icons/sphere_planet.svg"
                  alt="Icône sphère"
                > Groupes d'organisations
              </h3>
              <div style="margin-left: 1em;">
                <label>
                  Ajouter cette organisation à des groupe d'organisations
                </label>
                <p>
                  L'ajout de cette organisation à un groupe d'organisation donnera accès aux données 
                  et collections de données associées à ce groupe d'organisation.
                </p>
                <SearchUsergroups
                  style="width: 60%;"
                  :types="['group-of-organisation']"
                  :limit="100"
                  @select="addOrgToSphere"
                />
                <div
                  v-if="selectedSpheres.length > 0"
                  id="orga-spheres-container"
                >
                  <div
                    v-for="selectedSphere of selectedSpheres"
                    :key="selectedSphere.id"
                    class="orga-sphere"
                  >
                    {{ selectedSphere.display_name }}
                    <b-icon-x
                      font-scale="1.5"
                      @click="removeOrgFromSphere"
                    />
                  </div>
                </div>
              </div>
            </div>
          </div>
          <div class="form-footer">
            <div>
              <b-button
                variant="outline-secondary"
                @click="$router.go(-1)"
              >
                Annuler
              </b-button>
            </div>
            <div class="btn-group-horizontal">
              <b-button
                style="margin-right: 0.8em;"
                variant="primary"
                @click="handleSubmit(addOrganisation)"
              >
                Enregistrer
              </b-button>
              <b-button
                variant="primary"
                @click="handleSubmit(addOrganisationAndContinue)"
              >
                Enregistrer et continuer
              </b-button>
            </div>
          </div>
        </form>
      </ValidationObserver>
    </div>
  </div>
</template>

<script>
import Multiselect from 'vue-multiselect';
import ImportImage from '@/components/ImportImage.vue';
import ImportFile from '@/components/ImportFile.vue';
import SearchUsergroups from '@/components/SearchUsergroups.vue';

import { mapState, mapMutations, mapActions } from 'vuex';

import { slugify } from '@/utils';

import { ValidationObserver, ValidationProvider, extend, configure } from 'vee-validate';
import { required, email } from 'vee-validate/dist/rules';


extend('required', {
  ...required,
  message: 'Ce champ est requis'
});
extend('email', {
  ...email,
  message: 'Veuillez entrer une adresse email valide'
});

configure({
  classes: {
    valid: 'is-valid',
    invalid: 'is-invalid'
  }
});

const LABEL_ID_COMP = process.env.VUE_APP_LABEL_ID_COMP;

export default {
  name: 'AddOrganisation',

  components: {
    Multiselect,
    ValidationObserver,
    ValidationProvider,
    ImportImage,
    ImportFile,
    SearchUsergroups
  },

  data() {
    return {
      routeFrom: null,
      failure: false,
      loading: false,
      disabled: true,
      territoireCheckbox: true,
      form: {
        additional_id: null,
        display_name: null,
        acronym: null,
        registration_number: null,
        organisation_type: null,
        website_url: null,
        phone_number: null,
        postal_address: null,
        description: null,
        thumbnail: null,
        jurisdiction: null,
        agreement_signed: false,
        agreement: null
      },
      selectedSpheres: [],
      labelIdComp: LABEL_ID_COMP
    }
  },

  computed: {
    ...mapState('organisations', [
      'organisationsTypes',
      'organisationsError',
      'lastCreatedOrganisation',
      'organisationsJuridictions'
    ]),
    ...mapState('form', [
      'currentFormId',
      'currentForm'
    ]),
    ...mapState('usergroups', [
      'currentUsergroup'
    ]),

    typesOrganisations() {
      return this.organisationsTypes.map((el, i) => {
        return {
          choice: i,
          label: el.display_name
        }
      });
    }
  },

  watch: {
    form: {
      deep: true,
      handler(newValue) {
        this.SET_CURRENT_FORM({
          id: 'addOrganisation',
          form: newValue
        });
      }
    },
    organisationsError(newValue) {
      if (newValue) {
        for (const [key, value] of Object.entries(newValue)) {
          this.$refs[key].applyResult({
            errors: value,
            valid: false,
            failedRules: {}
          });
        }
      }
    }
  },

  beforeRouteEnter(to, from, next) {
    next((vm) => {
        vm.routeFrom = from;
    });
  },

  created() {
    this.loading = true
    Promise.all([
      this.GET_ORGANISATIONS_TYPES(),
      this.GET_ORGANISATIONS_JURIDICTIONS()
    ]).then(() => {
      this.loading = false;
    });
    if (this.currentFormId === 'addOrganisation') {
      this.form = {
        ...this.form,
        ...this.currentForm
      }
    }
  },

  methods: {
    ...mapMutations('form', [
      'SET_CURRENT_FORM'
    ]),
    ...mapMutations('organisations', [
      'SET_LAST_CREATED_ORGANISATION'
    ]),
    ...mapActions('organisations', [
      'GET_ORGANISATIONS_TYPES',
      'CREATE_ORGANISATION',
      'SET_ORGANISATION_THUMBNAIL',
      'SET_ORGANISATION_AGREEMENT',
      'GET_ORGANISATIONS_JURIDICTIONS'
    ]),
    ...mapActions('usergroups', [
      'GET_USERGROUPS_LIST',
      'GET_USERGROUP_DETAIL',
      'UPDATE_USERGROUP'
    ]),

    setThumbnail(e) {
      const formData = new FormData();
      formData.append('file', e);
      this.form.thumbnail = formData;
    },

    setAgreement(e) {
      const formData = new FormData();
      formData.append('file', e);
      this.form.agreement = formData;
    },

    addOrgToSphere(e) {
      const index = this.selectedSpheres.findIndex(el => el.id === e.id);
      if (index === -1) {
        this.selectedSpheres.push(e);
      }
      this.sphere = null;
    },

    removeOrgFromSphere(e) {
      const index = this.selectedSpheres.findIndex(el => el.id === e.id);
      this.selectedSpheres.splice(index, 1);
    },

    addOrganisation() {
      this.loading = true;
      const data = {
        additional_id: this.form.additional_id,
        display_name: this.form.display_name,
        codename: slugify(this.form.display_name),
        acronym: this.form.acronym,
        registration_number: this.form.registration_number,
        organisation_type: this.organisationsTypes.find(el => el.display_name === this.form.organisation_type.label),
        is_active: true,
        postal_address: this.form.postal_address,
        description: this.description,
        website_url: this.form.website_url,
        phone_number: this.form.phone_number,
        agreement_signed: this.form.agreement_signed,
        jurisdiction: this.territoireCheckbox ? null : this.form.jurisdiction
      };
      this.CREATE_ORGANISATION(data)
        .then(() => {
          if (this.lastCreatedOrganisation) {
            Promise.all([
              this.form.thumbnail ? this.SET_ORGANISATION_THUMBNAIL({
                id: this.lastCreatedOrganisation.id,
                data: this.form.thumbnail
              }) : Promise.resolve(),
              this.form.agreement ? this.SET_ORGANISATION_AGREEMENT({
                id: this.lastCreatedOrganisation.id,
                data: this.form.agreement
              }) : Promise.resolve(),
              this.selectedSpheres.length > 0 ?
                this.GET_USERGROUP_DETAIL(this.lastCreatedOrganisation.usergroup.id)
                  .then(() => {
                    this.UPDATE_USERGROUP({
                      id: this.currentUsergroup.id,
                      data: {
                        ...this.currentUsergroup,
                        parents: this.selectedSpheres.map((el) => { return el.id; })
                      }
                    })
                  }) : Promise.resolve(),
              this.GET_USERGROUPS_LIST({
                direction: null,
                field: null,
                usergroupTypes: []
              })
            ]).then(() => {
              this.SET_LAST_CREATED_ORGANISATION(null);
              this.SET_CURRENT_FORM({
                id: null,
                form: {}
              });
              this.loading = false;
              this.$router.push({ name: 'Organisations' });
            });
          } else {
            this.loading = false;
          }
        })
        .catch(() => {
          this.form = this.currentForm;
          this.loading = false;
        });
    },

    addOrganisationAndContinue() {
      this.loading = true;
      const data = {
        additional_id: this.form.additional_id,
        display_name: this.form.display_name,
        codename: slugify(this.form.display_name),
        acronym: this.form.acronym,
        registration_number: this.form.registration_number,
        organisation_type: this.organisationsTypes.find(el => el.display_name === this.form.organisation_type.label),
        is_active: true,
        postal_address: this.form.postal_address,
        description: this.description,
        website_url: this.form.website_url,
        phone_number: this.form.phone_number,
        agreement_signed: this.form.agreement_signed,
        jurisdiction: this.territoireCheckbox ? null : this.form.jurisdiction
      };
      this.CREATE_ORGANISATION(data)
        .then(() => {
          if (this.lastCreatedOrganisation) {
            Promise.all([
              this.form.thumbnail ? this.SET_ORGANISATION_THUMBNAIL({
                id: this.lastCreatedOrganisation.id,
                data: this.form.thumbnail
              }) : Promise.resolve(),
              this.form.agreement ? this.SET_ORGANISATION_AGREEMENT({
                id: this.lastCreatedOrganisation.id,
                data: this.form.agreement
              }) : Promise.resolve(),
              this.selectedSpheres.length > 0 ?
                this.GET_USERGROUP_DETAIL(this.lastCreatedOrganisation.usergroup.id)
                  .then(() => {
                    this.UPDATE_USERGROUP({
                      id: this.currentUsergroup.id,
                      data: {
                        ...this.currentUsergroup,
                        parents: this.selectedSpheres.map((el) => { return el.id; })
                      }
                    })
                  }) : Promise.resolve(),
              this.GET_USERGROUPS_LIST({
                direction: null,
                field: null,
                usergroupsTypes: []
              })
            ]).then(() => {
              this.loading = false;
              this.$router.push({ name: 'OrganisationDetail', params: { id: this.lastCreatedOrganisation.id } });
              this.SET_LAST_CREATED_ORGANISATION(null);
            });
          } else {
            this.loading = false;
          }
        })
        .catch(() => {
          this.form = this.currentForm;
          this.loading = false;
        });
    }
  },

};
</script>

<style lang="less" scoped>
.add-orga-form {
  margin-left: max(2em, auto);
  margin-right: max(2em, auto);
}

form {
  min-width: 800px;
  max-width: 1000px;
}

h2 {
  color: @blue;
  margin-top: 0.5em;
  margin-left: 0.5em;
}

h4 {
  color: @blue;
  margin-top: 0.8em;
}

#orga-spheres-container {
  display: flex;
  flex-flow: row wrap;
  padding: 0.1em;
  margin: 0.5em 0;
  .orga-sphere {
    display: flex;
    margin: 0.2em 1em 0.2em 0;
    padding: 0.5em;
    border-radius: 10px;
    font-size: 0.9em;
    background-color: @blue;
    color: white;
    .b-icon {
      cursor: pointer;
    }
  }
}
</style>
